package net.jieyuu.exception;


import com.alibaba.csp.sentinel.adapter.spring.webmvc.callback.BlockExceptionHandler;
import com.alibaba.csp.sentinel.slots.block.BlockException;
import com.alibaba.csp.sentinel.slots.block.authority.AuthorityException;
import com.alibaba.csp.sentinel.slots.block.degrade.DegradeException;
import com.alibaba.csp.sentinel.slots.block.flow.FlowException;
import net.jieyuu.enums.BizCodeEnum;
import net.jieyuu.utils.CommonUtil;
import net.jieyuu.utils.JsonData;
import org.springframework.stereotype.Component;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;

/**
 * sentinel 限流异常处理器
 */
@Component
public class XdclassUrlBlockHandler implements BlockExceptionHandler {
    @Override
    public void handle(HttpServletRequest httpServletRequest, HttpServletResponse httpServletResponse, BlockException e) throws IOException {
        JsonData jsondata = null;
        if (e instanceof FlowException) {
            jsondata = JsonData.buildResult(BizCodeEnum.CONTROL_FLOW);
        } else if (e instanceof DegradeException) {
            jsondata = JsonData.buildResult(BizCodeEnum.CONTROL_DEGRADE);
        } else if (e instanceof AuthorityException) {
            jsondata = JsonData.buildResult(BizCodeEnum.CONTROL_AUTH);
        }
        httpServletResponse.setStatus(200);
        CommonUtil.sendJsonMessage(httpServletResponse, jsondata);
    }
}